#include <stdint.h>
#include <string.h>

#include "STM32F767_types.h"

/* Defines */
#define PORTA 0
#define PORTB 1
#define PORTC 2
#define PORTD 3
#define PORTE 4
#define PORTF 5
#define PORTG 6

#define GPIO_INPUT              0
#define GPIO_OUTPUT             1
#define GPIO_PULLUP             2
#define GPIO_PULLDOWN           3
#define GPIO_NO_PULLUP_PULLDOWN 4

/* Prototypes */
void wait_cycles(int N);
void setup_clock_HSI(uint32_t N, uint32_t M, uint32_t P, uint32_t Q, uint32_t R);
void setup_clock_HSE_bypass(uint32_t N, uint32_t M, uint32_t P, uint32_t Q, uint32_t R);
void initGPIO();
uint8_t getPinState(uint8_t port, uint8_t pin);
void setPinState(uint8_t port, uint8_t pin, uint8_t state);
void setPinDir(uint8_t port, uint8_t pin, uint8_t dir);
void setPinDirExt(uint8_t port, uint8_t pin, uint8_t dir, uint8_t pullup);
void setAlternateFunction(uint8_t port, uint8_t pin, uint8_t AF);
