clear all;
close all;

N = 1024;
Offset = 2048;
Ampl = 2047;

theta = linspace(0, 2*pi, N);
sine_table = (Ampl * sin(theta));

for i = 1:N
  cosine_table(i) = sine_table(mod(i + 256, N) + 1);
endfor;

figure;
hold on;
plot(sine_table);
plot(cosine_table);
grid on;

fileID = fopen('sine_table.c', 'w');
for i = 1:length(sine_table)
  fprintf(fileID, '        %ld,\n', (int32)(sine_table(i)));
endfor;
fclose(fileID);
